#shader vertex
#version 400

layout(location = 0) in vec3 a_Position;
layout(location = 1) in vec4 a_Color;
layout(location = 2) in vec2 a_TexPos;
layout(location = 3) in vec2 a_TexSize;
layout(location = 4) in float a_TexID;
layout(location = 5) in mat4 a_Transform;

uniform mat4 u_ViewProjection;

out vec4 v_Color;
out vec2 v_texCoord;
out float v_texID;

void main() {
  gl_Position = u_ViewProjection * a_Transform * vec4(a_Position, 1.0f);
  v_texCoord = a_TexPos + a_TexSize;
  v_texID = a_TexID;
  v_Color = a_Color;
}

#shader fragment
#version 400

in vec4 v_Color;
in vec2 v_texCoord;
in float v_texID;

uniform sampler2D u_Textures[32];

void main() {
  if (v_texID == -1) {
    gl_FragColor = v_Color;
  } else {

    vec4 color = texture(u_Textures[int(v_texID)], v_texCoord);

    if (color.a <= 0.0) {
        discard;
    }

    gl_FragColor = color;
  }
}
